#include <ggi/ggiart.h>
/* gcc test1.c -o test1 -lart_lgpl -lggi -lggiart */

int main() {

  
  ggi_visual_t vis;
  ggi_mode mode;
  ggi_color color;

  struct ggiart_buffer_s b1;
  ggiart_svp_t    svp;
  int dxdy[2],i,j;

  struct ggiart_rop_s rops;
  struct ggiart_rop_s rops2;
  
  rops.rop=GGIART_ROP_COLOR;
  rops.arg1=(void*)(&color);
  rops2.rop=GGIART_ROP_TEXTURE;
  rops2.arg1=(void*)(&b1);
  rops2.arg2=(void*)(&dxdy);

  ggiInit();
  ggiartInit();
  vis=ggiOpen(NULL);
  
  ggiCheckGraphMode(vis,320,200,320,200,GT_32BIT,&mode);
  ggiSetMode(vis,&mode);
  
  ggiartAttach(vis);
  
  ggiAddFlags(vis, GGIFLAG_ASYNC);

  color.r=0xffff; color.g=0xffff; color.b=0xffff;
  ggiSetGCForeground(vis,ggiMapColor(vis,&color));
  ggiFillscreen(vis);
  ggiFlush(vis);


  svp = art_svp_vpath_stroke(art_vpath_new_circle(100,150,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,10,4,7);
  color.r=0x0; color.g=0x8fff; color.b=0x0; color.a=0x8fff;
  ggiartRenderSVP(vis,svp,NULL,&rops);
  ggiFlush(vis);
  ggiGetc(vis);

  b1.width=20;
  b1.height=20;
  b1.pixels=malloc(sizeof(*b1.pixels)*b1.width*b1.height);
  for(i=0;i<b1.width;i++)
    for(j=0;j<b1.height;j++) {
      b1.pixels[j*b1.width+i].r=0xffff;
      b1.pixels[j*b1.width+i].g=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].b=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].a=0x8fff;
      
    }
  dxdy[0]=0;
  dxdy[1]=0;
  svp = art_svp_vpath_stroke(art_vpath_new_circle(90,90,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,20,4,7);
  ggiartRenderSVP(vis,svp,NULL,&rops2);
  ggiFlush(vis);
  ggiGetc(vis);

  for(i=0;i<b1.width;i++)
    for(j=0;j<b1.height;j++) {
      b1.pixels[j*b1.width+i].r=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].g=0xffff*((j<b1.height/2)&&(i<b1.height/2)||(j>=b1.height/2)&&(i>=b1.height/2));
      b1.pixels[j*b1.width+i].b=0xffff;
      b1.pixels[j*b1.width+i].a=0x6fff;
      
    }
  svp = art_svp_vpath_stroke(art_vpath_new_circle(180,95,75),
			     ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,25,4,7);
  ggiartRenderSVP(vis,svp,NULL,&rops2);


  ggiFlush(vis);
  
  /*ggiFlush(vis);*/
  ggiGetc(vis);
  
  ggiartDetach(vis);

  ggiClose(vis);
  ggiartExit();
  ggiExit();

  return 0;
}
